<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label">
          ¿ Tiene cuentas por cobrar ?
        </label>
        <p-radio class="d-inline-block" v-model="bandera" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="bandera" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="bandera == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Uso o beneficios en especie propiedad de un tercero</legend>
        </div>
        <div class="row">

          <div class="form-group col-md-4">
            <label class="control-label">Tipo de Bien</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_bienes.tipo_bien_id">
              <el-option v-for="option in bienes" class="select-default" :value="option.id" :label="option.valor" :key="option.valor"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4" v-if=" item_bienes.tipo_bien_id == 4">
            <label class="control-label">Especificar tipo bien</label>
            <input class="form-control" type="text" v-model="item_bienes.tipo_bien_especificar" placeholder="Especificar">
          </div>

          <div class="form-group col-md-4 customCurrency">
            <label class="control-label">Valor de mercado aproximado</label>
            <b-input-group size="sm" :prepend="getSigno">
              <b-form-input type="number" class="text-right" v-model="item_bienes.valor_mercado_valor" placeholder="0" @keyup.native="isNumber" />
              <b-dropdown right split :text="getCodigoMoneda" v-model="item_bienes.valor_mercado_cat_moneda_id">
                <b-dropdown-item v-for="option in monedas" :key="option.codigo" :value="option.codigo" @click="item_bienes.valor_mercado_cat_moneda_id = option.id">{{option.moneda}}</b-dropdown-item>
              </b-dropdown>
            </b-input-group>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Nombre, denominación o razón social </label>
            <input class="form-control" type="text" v-model="item_bienes.nombre_tercero_propietario" placeholder="Nombre del tercero propietario ">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">RFC del tercero propietario (si aplica)</label>
            <input class="form-control" type="text" v-model="item_bienes.rfc_tercero_propietario" placeholder="RFC">
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">CURP del tercero propietario (si aplica)</label>
            <input class="form-control" type="text" v-model="item_bienes.curp_tercero_propietario" placeholder="CURP">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Relación con la persona a quien se le adquirió el inmueble:</label>
            <el-select  clearable class="select-default" placeholder="Relación" v-model="item_bienes.relacion_persona_id">
              <el-option v-for="option in relaciones" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4" v-if=" item_bienes.relacion_persona_id == 5">
            <label class="control-label">Especificar relación</label>
            <input class="form-control" type="text" v-model="item_bienes.relacion_especificar" placeholder="Especificar Relación ">
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Sector / Industria (si aplica)</label>
            <el-select  clearable class="select-default" placeholder="Seleccione una opción" v-model="item_bienes.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>

          <div class="form-group col-md-4">
            <label class="control-label">Fecha de inicio</label>
            <div class="form-group">
              <el-date-picker type="date" v-model="item_bienes.fecha_inicio" value-format="dd-MM-yyyy" format="dd-MM-yyyy" placeholder="Seleccione fecha"></el-date-picker>
            </div>
          </div>

          <div class="form-group col">
            <label class="control-label">Observaciones / Comentarios</label>
            <input class="form-control" type="text" v-model="item_bienes.observaciones" placeholder="Observaciones / Comentarios">
          </div>
        </div>

        <domicilio titulo="de prestatarios (si aplica)" v-model="n_domicilio"></domicilio>

        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>

            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar
            </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_uso_bienes" responsive hover :items="list_bienes" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>

              <template slot="domicilio_entidad_federativa_id" slot-scope="row">
                {{getEntidad(row.item.domicilio_entidad_federativa_id)}}</template>
              <template slot="domicilio_localidad_id" slot-scope="row">
                {{getLocalidad(row.item.domicilio_localidad_id)}}
              </template>
              <template slot="domicilio_municipio_id" slot-scope="row">{{getMunicipio(row.item.domicilio_municipio_id)}}</template>
              <template slot="domicilio_pais_id" slot-scope="row">{{getPais(row.item.domicilio_pais_id)}}</template>

              <template slot="valor_mercado_valor" slot-scope="row" class="text-right">{{(getSignoDos(row.item.valor_mercado_cat_moneda_id))}}
                {{row.item.valor_mercado_valor | currency}}</template>
              <template slot="valor_mercado_cat_moneda_id" slot-scope="row" class="text-center">
                {{getMoneda(row.item.valor_mercado_cat_moneda_id)}}</template>

              <template slot="sector_industria_id" slot-scope="row">{{getSector(row.item.sector_industria_id)}}</template>
              <template slot="tipo_bien_id" slot-scope="row">{{getTipo(row.item.tipo_bien_id)}}</template>

            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker,
    InputNumber
  } from "element-ui";
  import Domicilio from "../Domicilio.vue";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      [InputNumber.name]: InputNumber,
      Domicilio
    },
    props: ["data"],
    data() {
      return {
        ip_id: 1,
        add_item: false,
        edit_item: null,
        bandera: '0',
        modelValidations: {
          nombre: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        },
        relaciones: null,
        bienes: null,
        sectores: null,
        n_domicilio: null,
        monedas: [],
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        paises: null,
        isnum: null,
        /* Lista de Bienes */
        item_bienes: {},
        list_bienes: [],
        fields_list: [{
            key: "acciones",
            label: "Acciones",
            tdClass: "text-center"
          },
          {
            key: "tipo_bien_id",
            label: "Tipo de bien",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "tipo_bien_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "valor_mercado_valor",
            label: "Valor de mercado aproximado",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "valor_mercado_cat_moneda_id",
            label: "Moneda",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "nombre_tercero_propietario",
            label: "Nombre o razón social",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "rfc_tercero_propietario",
            label: "RFC del tercero propietario",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "curp_tercero_propietario",
            label: "CURP del tercero propietario ",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "relacion_persona_id",
            label: "Relación con la persona ",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "relacion_especificar",
            label: "Especificar",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "sector_industria_id",
            label: "Sector / Industria",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "fecha_inicio",
            label: "Fecha de inicio",
            tdClass: "text-center",
            formatter: 'emptyFields'
          },
          {
            key: "observaciones",
            label: "Observaciones / Comentarios",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_pais_id",
            label: "País",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_entidad_federativa_id",
            label: "Entidad federativa",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_municipio_id",
            label: "Municipio",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_localidad_id",
            label: "Localidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_colonia",
            label: "Colonia",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_vialidad_tipo",
            label: "Tipo vialidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_vialidad_nombre",
            label: "Nombre vialidad",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_cp",
            label: "CP",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_numExt",
            label: "Número exterior",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "domicilio_numInt",
            label: "Número interior",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
        ]
      };
    },
    computed: {
      getSigno() {
        var signo = "$";
        var val = this.item_bienes.valor_mercado_cat_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      getCodigoMoneda() {
        var codigo = "MXN";
        var val = this.item_bienes.valor_mercado_cat_moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            codigo = item.codigo;
          }
        });
        return codigo;
      },
    },
    watch: {
      n_domicilio: {
        handler: function () {
          if (this.n_domicilio) {
            this.item_bienes.domicilio_pais_id = this.n_domicilio.pais_id ? this.n_domicilio.pais_id : 150;
            this.item_bienes.domicilio_entidad_federativa_id = this.n_domicilio.entidadF ? this.n_domicilio.entidadF : "";
            this.item_bienes.domicilio_municipio_id = this.n_domicilio.municipio ? this.n_domicilio.municipio : "";
            this.item_bienes.domicilio_localidad_id = this.n_domicilio.localidad ? this.n_domicilio.localidad : "";
            this.item_bienes.domicilio_cp = this.n_domicilio.cp ? this.n_domicilio.cp : "";
            this.item_bienes.domicilio_colonia = this.n_domicilio.colonia ? this.n_domicilio.colonia : "";
            this.item_bienes.domicilio_vialidad_tipo = this.n_domicilio.vialidad ? this.n_domicilio.vialidad : "";
            this.item_bienes.domicilio_vialidad_nombre = this.n_domicilio.vialidad_nombre ? this.n_domicilio.vialidad_nombre : "";
            this.item_bienes.domicilio_numExt = this.n_domicilio.ext ? this.n_domicilio.ext : "";
            this.item_bienes.domicilio_numInt = this.n_domicilio.int ? this.n_domicilio.int : "";
          }
        },
        deep: true
      },
      list_bienes: {
        handler: function () {
          if (this.list_bienes) {
            this.setLocalidades();
            if (this.list_bienes.length == 0) {
              this.bandera = '0';
            } else {
              this.bandera = '1';
            }
          }
        },
        deep: true
      },
    },
    methods: {
      getSignoDos(val = "97") {
        var signo = "$";
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      emptyFields(value) {
        if (value) {
          if (typeof value === 'string' || value instanceof String) {
            return value.toUpperCase();
          } else {
            return value;
          }
        } else {
          return '-';
        }
      },
      getEntidad(index) {
        var resp = " ";
        if (this.entidadFed) {
          this.entidadFed.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_ent;
              return resp;
            }
          });
        }
        return resp;
      },
      getSector(index) {
        var resp = " ";
        if (this.sectores) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getRelacion(index) {
        var resp = " ";
        if (this.relaciones) {
          this.relaciones.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getTipo(index) {
        var resp = " ";
        if (this.bienes) {
          this.bienes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMoneda(index) {
        var resp = "";
        if (this.monedas) {
          this.monedas.forEach(function (item) {
            if (item.id == index) {
              resp = item.moneda;
            }
          });
        }
        return resp;
      },
      getLocalidad(index) {
        var resp = "";
        if (this.localidades) {
          this.localidades.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_loc;
              return resp;
            }
          });
        }
        return resp;
      },
      getMunicipio(index) {
        var resp = "";
        if (this.municipios) {
          this.municipios.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_mun;
              return resp;
            }
          });
        }
        return resp;
      },
      getPais(index) {
        var resp = "México";
        if (this.paises) {
          this.paises.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      initItem() {
        this.n_domicilio = {
          pais_id: 150,
          entidadF: '',
          municipio: '',
          localidad: '',
          cp: '',
          colonia: '',
          vialidad: '',
          vialidad_nombre: '',
          ext: '',
          int: ''
        };
        this.item_bienes = {
          acciones: "",
          tipo_bien_id: "",
          valor_mercado_valor: "",
          valor_mercado_cat_moneda_id: 97,
          nombre_tercero_propietario: "",
          rfc_tercero_propietario: "",
          curp_tercero_propietario: "",
          relacion_persona_id: "",
          sector_industria_id: "",
          fecha_inicio: "",
          observaciones: "",
          tipo_bien_especificar: "",
          relacion_especificar: "",
          domicilio_pais_id: 150,
          domicilio_entidad_federativa_id: "",
          domicilio_municipio_id: "",
          domicilio_localidad_id: "",
          domicilio_colonia: "",
          domicilio_vialidad_nombre: "",
          domicilio_vialidad_tipo: "",
          domicilio_cp: "",
          domicilio_numExt: "",
          domicilio_numInt: "",
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        if (this.item_bienes) {
          this.item_bienes.ip_id = this.ip_id;
          this.loadButton(this.$refs.btnSave);
          this.$http.post("uso_beneficios", this.item_bienes).then(
            response => {
              this.StepOk("Guardado");
              if (this.edit_item === undefined || this.edit_item === null) {
                this.list_bienes.push({
                  ...response.data.bien
                });
              } else {
                this.list_bienes.splice(
                  this.edit_item.index,
                  1,
                  this.item_bienes
                );
                this.edit_item.item._rowVariant = "";
              }
              this.showItem();
              this.initItem();
              this.edit_item = null;
            },
            error => {
              this.StepError(error);
              //this.change =  true;
            }
          );
        } else {
          this.StepW("Hay campos sin completar");
        }
        //console.log(this.item_bienes);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_bienes = {
          ...this.list_bienes[this.edit_item.index]
        };
        this.editDomicilio();
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
            scrollTop: 100
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_bienes[indice].id !== null) {
          let item = this.list_bienes[indice];
          //this.list_bienes.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("uso_beneficios/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_bienes.splice(indice, 1);
              },
              error => {
                this.Err(error);
              }
            );
          });
        }
      },
      editDomicilio() {
        this.n_domicilio.pais_id = this.item_bienes.domicilio_pais_id ? this.item_bienes.domicilio_pais_id : 150;
        this.n_domicilio.entidadF = this.item_bienes.domicilio_entidad_federativa_id ? this.item_bienes.domicilio_entidad_federativa_id : '';
        this.n_domicilio.municipio = this.item_bienes.domicilio_municipio_id ? this.item_bienes.domicilio_municipio_id : '';
        this.n_domicilio.localidad = this.item_bienes.domicilio_localidad_id ? this.item_bienes.domicilio_localidad_id : '';
        this.n_domicilio.cp = this.item_bienes.domicilio_cp ? this.item_bienes.domicilio_cp : '';
        this.n_domicilio.colonia = this.item_bienes.domicilio_colonia ? this.item_bienes.domicilio_colonia : '';
        this.n_domicilio.vialidad = this.item_bienes.domicilio_vialidad_tipo ? this.item_bienes.domicilio_vialidad_tipo : '';
        this.n_domicilio.vialidad_nombre = this.item_bienes.domicilio_vialidad_nombre ? this.item_bienes.domicilio_vialidad_nombre : '';
        this.n_domicilio.ext = this.item_bienes.domicilio_numExt ? this.item_bienes.domicilio_numExt : '';
        this.n_domicilio.int = this.item_bienes.domicilio_numInt ? this.item_bienes.domicilio_numInt : '';
      },
      validate() {
        return this.$validator.validateAll();
      },
      setLocalidades() {
        this.localidades = [];
        this.list_bienes.forEach((item) => {
          if (item.domicilio_localidad_id) {
            this.$http.get('localidades/localidad/' + item.domicilio_localidad_id).then(
              response => {
                this.localidades.push(response.data.localidad);
              },
              error => {
                this.Err(error);
              }
            );
          }
        });
      },
      isNumber(n) {
        //console.log(n);
        n.target.value = n.target.value.replace(/[^\d.-]/g, '');
      }
    },
    created() {
      this.initItem();
      //this.getLocalidades(97250);
      this.$http.get("uso_beneficios/" + this.ip_id).then(
        response => {
          this.list_bienes = response.data.bienes;
          this.setLocalidades();
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("entidadFed").then(
        response => {
          this.entidadFed = response.data.entidadfed;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("paises").then(
        response => {
          this.paises = response.data.pais;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("municipios").then(
        response => {
          this.municipios = response.data.municipios;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_tipo_bien").then(
        response => {
          this.bienes = response.data.tipos;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_relacion_persona_adquirio").then(
        response => {
          this.relaciones = response.data.relaciones;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_sector_industria").then(
        response => {
          this.sectores = response.data.sectores;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("monedas").then(
        response => {
          this.monedas = response.data.monedas;
        },
        error => {
          this.Err(error);
        }
      );
      if (this.data) {}
    }
  };

</script>
<style>


</style>
